# PIP: src/core/pibytearray.h File Reference

pibytearray.h File Reference

Byte array. More...

## Classes

class | PIByteArray
| Byte array. More...
struct | PIByteArray::RawData
| Help struct to store/restore custom blocks of data to/from PIByteArray. More...

## Macros

#define | PIP_BYTEARRAY_STREAM_ANY_TYPE
| This macro allow stream template operators for write and read any type from byte array. Use it with attention!

## Functions

std::ostream & | operator<< (std::ostream &s, const PIByteArray &ba)
| Output to std::ostream operator.
PICout | operator<< (PICout s, const PIByteArray &ba)
| Output to PICout operator.
PIByteArray & | operator<< (PIByteArray &s, uchar v)
| Store operator.
PIByteArray & | operator<< (PIByteArray &s, const short v)
| Store operator.
PIByteArray & | operator<< (PIByteArray &s, const int v)
| Store operator.
PIByteArray & | operator<< (PIByteArray &s, const long &v)
| Store operator.
PIByteArray & | operator<< (PIByteArray &s, const llong &v)
| Store operator.
PIByteArray & | operator<< (PIByteArray &s, const ushort v)
| Store operator.
PIByteArray & | operator<< (PIByteArray &s, const uint v)
| Store operator.
PIByteArray & | operator<< (PIByteArray &s, const ulong &v)
| Store operator.
PIByteArray & | operator<< (PIByteArray &s, const ullong &v)
| Store operator.
PIByteArray & | operator<< (PIByteArray &s, const float v)
| Store operator.
PIByteArray & | operator<< (PIByteArray &s, const double &v)
| Store operator.
PIByteArray & | operator<< (PIByteArray &s, const PIByteArray &v)
| Store operator, see Attention for details.
PIByteArray & | operator<< (PIByteArray &s, const PIByteArray::RawData &v)
| Store operator, see Attention for details.
template<typename Type0 , typename Type1 >
PIByteArray & | operator<< (PIByteArray &s, const PIPair< Type0, Type1 > &v)
| Store operator.
template<typename T >
PIByteArray & | operator<< (PIByteArray &s, const PIVector< T > &v)
| Store operator.
template<typename T >
PIByteArray & | operator<< (PIByteArray &s, const PIList< T > &v)
| Store operator.
template<typename T >
PIByteArray & | operator<< (PIByteArray &s, const PIDeque< T > &v)
| Store operator.
PIByteArray & | operator>> (PIByteArray &s, uchar &v)
| Restore operator.
PIByteArray & | operator>> (PIByteArray &s, short &v)
| Restore operator.
PIByteArray & | operator>> (PIByteArray &s, int &v)
| Restore operator.
PIByteArray & | operator>> (PIByteArray &s, long &v)
| Restore operator.
PIByteArray & | operator>> (PIByteArray &s, llong &v)
| Restore operator.
PIByteArray & | operator>> (PIByteArray &s, ushort &v)
| Restore operator.
PIByteArray & | operator>> (PIByteArray &s, uint &v)
| Restore operator.
PIByteArray & | operator>> (PIByteArray &s, ulong &v)
| Restore operator.
PIByteArray & | operator>> (PIByteArray &s, ullong &v)
| Restore operator.
PIByteArray & | operator>> (PIByteArray &s, float &v)
| Restore operator.
PIByteArray & | operator>> (PIByteArray &s, double &v)
| Restore operator.
PIByteArray & | operator>> (PIByteArray &s, PIByteArray &v)
| Restore operator, see Attention for details.
PIByteArray & | operator>> (PIByteArray &s, PIByteArray::RawData v)
| Restore operator, see Attention for details.
template<typename Type0 , typename Type1 >
PIByteArray & | operator>> (PIByteArray &s, PIPair< Type0, Type1 > &v)
| Restore operator.
template<typename T >
PIByteArray & | operator>> (PIByteArray &s, PIVector< T > &v)
| Restore operator.
template<typename T >
PIByteArray & | operator>> (PIByteArray &s, PIList< T > &v)
| Restore operator.
template<typename T >
PIByteArray & | operator>> (PIByteArray &s, PIDeque< T > &v)
| Restore operator.
bool | operator== (PIByteArray &f, PIByteArray &s)
| Byte arrays compare operator.
bool | operator!= (PIByteArray &f, PIByteArray &s)
| Byte arrays compare operator.

## Detailed Description

Byte array.